{%- import "src/_contributor_contact.j2" as contributor with context -%}
{%- import "src/_dataset.j2" as dataset with context -%}
{%- import "src/_utils.j2" as utils with context -%}

{#- ----------------------------------------------------------------------- -#}
{#-  GLOBAL VARIABLES                                                       -#}
{#- ----------------------------------------------------------------------- -#}

{#- this global namespace stack will be used to exlusively store stuff -#}
{#- to help us monitor the sequence of annotations as they appear  -#}
{#- and the paths traversed  -#}

{#- ------------------------------------------------------------  -#}
{#- globals to THIS file, which we call locals... -#}
{#- ------------------------------------------------------------  -#}
{#- variables global to this file, not meant to be used by the caller  -#}

{%- set local_ns = namespace(description="itemList paths, annotations") -%}

{%- set local_ns.annotations_encountered_stack = [] -%}

{#- ------------------------------------------------------------  -#}
{#- end of globals  -#}
{#- ------------------------------------------------------------  -#}


{%- macro trackItemListStart()  -%}
  {%- do local_ns.annotations_encountered_stack.append([]) -%}
  {#-  {{ "\nappend to annotation stack" }} -#}
  {#- we always append for each item list where there is an answer -#}
{%- endmacro  -%}


{%- macro trackAnnotation(annotation)  -%} 
  {%- set size = local_ns.annotations_encountered_stack|length  -%} 

{#-  {{ "\nannotation " ~ annotation ~ " size " ~ size }} -#}
  {%- do local_ns.annotations_encountered_stack[size - 1].append(annotation) -%} 
{%- endmacro  -%}


{#- complete dataset creation  is denoted by the following annotation -#}
{%- set local_ns.dataset_creation_annotation = "Dataset" -%}


{%- macro completeDatasetItemList(globals, dmp_being_built) -%}
  {%- set last_annotations = local_ns.annotations_encountered_stack.pop() -%}
  {%- if last_annotations -%}
    {#- we need only check if the creation annotation is present  -#}
    {%- if local_ns.dataset_creation_annotation in last_annotations  -%}
      {{ dataset.doLastSetOfDatasetClones(globals, dmp_being_built) }}
    {%- endif -%}
  {%- endif -%}
  {#-  {{ "\nremove from annotation stack" }} -#}
{%- endmacro  -%}


{%- macro processItemListEnd(globals) -%}
  {%- set dmp_being_built = globals.global_ns.main_vars.dmp_being_built -%}
  {{ completeDatasetItemList(globals, dmp_being_built) }}
{%- endmacro  -%}
